<p align="center">
<img width="886" alt="2017-07-08 12 04 59" src="https://user-images.githubusercontent.com/8784712/27982511-c77326d6-63d5-11e7-90fc-5d162d52cd7a.png">
</p>

<p align="center">
<a href="https://npmjs.com/package/bili"><img src="https://img.shields.io/npm/v/bili.svg?style=flat-square" alt="NPM version"></a>
<a href="https://npmjs.com/package/bili"><img src="https://img.shields.io/npm/dm/bili.svg?style=flat-square" alt="NPM downloads"></a>
<a href="https://circleci.com/gh/egoist/bili/tree/master"><img src="https://img.shields.io/circleci/project/egoist/bili/master.svg?style=flat-square"></a>
<a href="https://codecov.io/gh/egoist/bili"><img src="https://img.shields.io/codecov/c/github/egoist/bili.svg?style=flat-square"></a>
<a href="https://github.com/egoist/donate"><img src="https://img.shields.io/badge/$-donate-ff69b4.svg?maxAge=2592000&amp;style=flat-square" alt="donate"></a>

</p>

## Introduction

Running command `bili` it will compile `src/index.js` to:

```bash
dist/[name].common.js # commonjs format
```

The `[name]` is `name` in `package.json` or `index` as fallback.

You can also generate UMD bundle and minify it with: `bili --format umd,umd-min`, then you get:

```bash
dist/[name].js          # umd format
dist/[name].min.js      # minified umd format
dist/[name].min.js.map  # minified file will automatically get sourcemaps
```

Not enough? You can have them all in one command `bili --format cjs,es,umd,umd-min`:

```bash
dist/[name].js          # umd format
dist/[name].min.js      # umd format and minified
dist/[name].min.js.map  # sourcemap for umd format
dist/[name].common.js   # commonjs format
dist/[name].es.js       # es-modules format
```

**Note:** In `UMD` format all third-party libraries will be bundled in dist files, while in other formats they are excluded.

## Install

```bash
npm install -g bili
# prefer local install
npm install bili --save-dev
```

[Dive into the documentation](https://egoistian.com/bili/) if you are ready to bundle!

## FAQ

### Why not use Rollup's `targets` option?

As per Rollup [wiki](https://github.com/rollup/rollup/wiki/Command-Line-Interface#targets):

```js
import buble from 'rollup-plugin-buble'

export default {
  input: 'src/main.js',
  plugins: [ buble() ],
  output: [
    { file: 'dist/bundle.cjs.js', format: 'cjs' },
    { file: 'dist/bundle.umd.js', format: 'umd' },
    { file: 'dist/bundle.es.js', format: 'es' },
  ]
}
```

You can use an array as `targets` to generate bundles in multiple formats, which is really neat and helpful.

However, you can't apply different plugins to different target, which means you still need more config files. For example, add `rollup-plugin-node-resolve` and `rollup-plugin-commonjs` in `umd` build, and what about minification? It's yet another config file.

While in bili, it's as simple as running:

```bash
bili src/main.js --format cjs,umd,es,umd-min
```

Everything can be done via CLI options, if it's too long to read, you can keep them in `bili` field in `package.json`:

```js
{
  "bili": {
    "entry": "src/main.js",
    "format": ["cjs", "umd", "es", "umd-min"]
  }
}
```

## License

MIT © [EGOIST](https://github.com/egoist)
