'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (file) {
  const config = (0, _utils.cwd)(file || 'bili.config.js');
  const pkgConfig = readInPkg((0, _utils.cwd)('package.json'));
  if (_fs2.default.existsSync(config)) {
    return Object.assign(require(config), pkgConfig);
  }
  return pkgConfig;
};

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function readInPkg(file) {
  try {
    const pkg = require(file);
    const bili = pkg.bili || {};
    if (pkg.name && !bili.filename) {
      const name = pkg.name;

      bili.filename = name.startsWith('@') ? name.slice(name.lastIndexOf('/') + 1) : name;
    }
    bili.pkg = pkg;
    return bili;
  } catch (err) {
    if (err.code === 'MODULE_NOT_FOUND') {
      return {
        // Ensure pkg in options
        pkg: {}
      };
    }
    throw err;
  }
}

// Read => bili.config.js & package.json