'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cwd = cwd;
exports.handleRollupError = handleRollupError;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cwd(...args) {
  return _path2.default.resolve(process.cwd(), ...args);
} /* eslint-disable import/prefer-default-export */
function handleRollupError(error) {
  (0, _log2.default)(error.plugin || 'error', error.message, _chalk2.default.red);
  if (error.id) {
    console.log(_chalk2.default.dim(`Location: ${error.id}`));
  }
  console.error(error.snippet);
  process.exitCode = 1;
}